--[[
AdiBags - Burning Crusade
by Zottelchen
version: 1.0.0
Items from the Burning Crusade expansion.
]]

local addonName, addon = ...
local AdiBags = LibStub("AceAddon-3.0"):GetAddon("AdiBags")

local L = addon.L
local MatchIDs
local Result = {}

local function AddToSet(...)
  local Set = {}
  for _, l in ipairs({ ... }) do
    for _, v in ipairs(l) do
      Set[v] = true
    end
  end
  return Set
end

local database = {}

-- Bandages
database["Bandages"] = {
  21990, -- Netherweave Bandage
  21991, -- Heavy Netherweave Bandage
}

-- Consumables
database["Consumables"] = {
  22728, -- Steam Tonk Controller
  23736, -- Fel Iron Bomb
  23737, -- Adamantite Grenade
  23819, -- Elemental Seaforium Charge
  23821, -- Zapthrottle Mote Extractor
  23826, -- The Bigger One
  23827, -- Super Sapper Charge
  23841, -- Gnomish Flame Turret
  31666, -- Battered Steam Tonk Controller
  32413, -- Frost Grenade
  34113, -- Field Repair Bot 110G
}

-- Foods and Drinks
database["FoodsandDrinks"] = {
  20857, -- Honey Bread
  22018, -- Conjured Glacier Water
  22019, -- Conjured Croissant
  22044, -- Mana Emerald
  22645, -- Crunchy Spider Surprise
  23329, -- Enriched Lasher Root
  23354, -- Crystalized Mana Residue
  23386, -- Condensed Mana Powder
  23495, -- Springpaw Appetizer
  23585, -- Stouthammer Lite
  23756, -- Cookie's Jumbo Gumbo
  23848, -- Nethergarde Bitter
  24006, -- Grunt's Waterskin
  24007, -- Footman's Waterskin
  24008, -- Dried Mushroom Rations
  24009, -- Dried Fruit Rations
  24072, -- Sand Pear Pie
  24105, -- Roasted Moongraze Tenderloin
  24338, -- Hellfire Spineleaf
  24408, -- Edible Stalks
  24539, -- Marsh Lichen
  24540, -- Edible Fern
  27553, -- Crimson Steer Energy Drink
  27635, -- Lynx Steak
  27636, -- Bat Bites
  27651, -- Buzzard Bites
  27655, -- Ravager Dog
  27657, -- Blackened Basilisk
  27658, -- Roasted Clefthoof
  27659, -- Warp Burger
  27660, -- Talbuk Steak
  27661, -- Blackened Trout
  27662, -- Feltail Delight
  27663, -- Blackened Sporefish
  27664, -- Grilled Mudfish
  27665, -- Poached Bluefish
  27666, -- Golden Fish Sticks
  27667, -- Spicy Crawdad
  27854, -- Smoked Talbuk Venison
  27855, -- Mag'har Grainbread
  27856, -- Skethyl Berries
  27857, -- Garadar Sharp
  27858, -- Sunspring Carp
  27859, -- Zangar Caps
  27860, -- Purified Draenic Water
  28112, -- Underspore Pod
  28284, -- Don Carlos Tequila
  28399, -- Filtered Draenic Water
  28486, -- Moser's Magnificent Muffin
  28501, -- Ravager Egg Omelet
  29112, -- Cenarion Spirits
  29292, -- Helboar Bacon
  29393, -- Diamond Berries
  29394, -- Lyribread
  29395, -- Ethermead
  29401, -- Sparkling Southshore Cider
  29412, -- Jessen's Special Slop
  29448, -- Mag'har Mild Cheese
  29449, -- Bladespire Bagel
  29450, -- Telaari Grapes
  29451, -- Clefthoof Ribs
  29452, -- Zangar Trout
  29453, -- Sporeggar Mushroom
  29454, -- Silverwine
  29531, -- Drums of Restoration
  30155, -- Clam Bar
  30355, -- Grilled Shadowmoon Tuber
  30357, -- Oronok's Tuber of Healing
  30358, -- Oronok's Tuber of Agility
  30359, -- Oronok's Tuber of Strength
  30361, -- Oronok's Tuber of Spell Power
  30457, -- Gilneas Sparkling Water
  30458, -- Stromgarde Muenster
  30610, -- Smoked Black Bear Meat
  30703, -- Conjured Mountain Spring Water
  30816, -- Spice Bread
  31451, -- Pure Energy
  31672, -- Mok'Nathal Shortribs
  31673, -- Crunchy Serpent
  32453, -- Star's Tears
  32455, -- Star's Lament
  32667, -- Bash Ale
  32668, -- Dos Ogris
  32685, -- Ogri'la Chicken Fingers
  32686, -- Mingo's Fortune Giblets
  32721, -- Skyguard Rations
  32722, -- Enriched Terocone Juice
  33023, -- Savory Sausage
  33024, -- Pickled Sausage
  33025, -- Spicy Smoked Sausage
  33026, -- The Golden Link
  33028, -- Barleybrew Light
  33029, -- Barleybrew Dark
  33030, -- Barleybrew Clear
  33031, -- Thunder 45
  33032, -- Thunderbrew Ale
  33033, -- Thunderbrew Stout
  33034, -- Gordok Grog
  33035, -- Ogre Mead
  33036, -- Mudder's Milk
  33042, -- Black Coffee
  33043, -- The Essential Brewfest Pretzel
  33048, -- Stewed Trout
  33052, -- Fisherman's Feast
  33053, -- Hot Buttered Trout
  33234, -- Iced Berry Slush
  33236, -- Fizzy Faire Drink "Classic"
  33246, -- Funnel Cake
  33254, -- Forest Strider Drumstick
  33825, -- Skullfish Soup
  33866, -- Stormchops
  33867, -- Broiled Bloodfin
  33872, -- Spicy Hot Talbuk
  33874, -- Kibler's Bits
  33924, -- Delicious Chocolate Cake
  34017, -- Small Step Brew
  34018, -- Long Stride Brew
  34019, -- Path of Brew
  34020, -- Jungle River Water
  34021, -- Brewdoo Magic
  34022, -- Stout Shrunken Head
  34062, -- Conjured Mana Biscuit
  34063, -- Dried Sausage
  34064, -- Succulent Sausage
  34065, -- Spiced Onion Cheese
  34410, -- Honeyed Holiday Ham
  34411, -- Hot Apple Cider
  34412, -- Sparkling Apple Cider
  34780, -- Naaru Ration
  34832, -- Captain Rumsey's Lager
  35563, -- Charred Bear Kabobs
  35565, -- Juicy Bear Burger
  35720, -- Lord of Frost's Private Label
  36799, -- Mana Gem
  38427, -- Pickled Egg
  38428, -- Rock-Salted Pretzel
  38429, -- Blackrock Spring Water
  38430, -- Blackrock Mineral Water
  38431, -- Blackrock Fortified Water
  38432, -- Plugger's Blackrock Ale
  38466, -- Sulfuron Slammer
}

-- Other Consumables
database["OtherConsumables"] = {
  21038, -- Hardpacked Snowball
  22778, -- Scourgebane Infusion
  22779, -- Scourgebane Draught
  22795, -- Fel Blossom
  23215, -- Bag of Smorc Ingredients
  23334, -- Cracked Power Core
  23381, -- Chipped Power Core
  23492, -- Suntouched Special Reserve
  23584, -- Loch Modan Lager
  23586, -- Aerie Peak Pale Ale
  23768, -- White Smoke Flare
  23769, -- Red Smoke Flare
  23771, -- Green Smoke Flare
  23857, -- Legacy of the Mountain King
  23862, -- Redemption of the Fallen
  23864, -- Torment of the Worgen
  23865, -- Wrath of the Titans
  23985, -- Crystal of Vitality
  23986, -- Crystal of Insight
  23989, -- Crystal of Ferocity
  24268, -- Netherweave Net
  24289, -- Chrono-Beacon
  24330, -- Drain Schematics
  24407, -- Uncatalogued Species
  24421, -- Nagrand Cherry
  24429, -- Expedition Flare
  24494, -- Tears of the Goddess
  24520, -- Honor Hold Favor
  24522, -- Thrallmar Favor
  24538, -- Fire Bomb
  24579, -- Mark of Honor Hold
  24581, -- Mark of Thrallmar
  25498, -- Rough Stone Statue
  25548, -- Tallstalk Mushroom
  25550, -- Redcap Toadstool
  25880, -- Coarse Stone Statue
  25881, -- Heavy Stone Statue
  25882, -- Solid Stone Statue
  25883, -- Dense Stone Statue
  25886, -- Purple Smoke Flare
  27317, -- Elemental Sapta
  27388, -- Mr. Pinchy
  27498, -- Scroll of Agility V
  27499, -- Scroll of Intellect V
  27500, -- Scroll of Protection V
  27501, -- Scroll of Versatility V
  27502, -- Scroll of Stamina V
  27503, -- Scroll of Strength V
  28132, -- Area 52 Special
  28513, -- Demonic Rune Stone
  28554, -- Shredder Spare Parts
  28571, -- Blank Scroll
  28580, -- B'naar Console Transcription
  28635, -- Sunfury Arcanist Robes
  28636, -- Sunfury Researcher Gloves
  28637, -- Sunfury Guardsman Medallion
  28784, -- Unyielding Banner Scrap
  28878, -- Inscription of Faith
  28881, -- Inscription of Discipline
  28882, -- Inscription of Warding
  28885, -- Inscription of Vengeance
  28886, -- Greater Inscription of Discipline
  28887, -- Greater Inscription of Faith
  28888, -- Greater Inscription of Vengeance
  28889, -- Greater Inscription of Warding
  28903, -- Inscription of the Orb
  28904, -- Inscription of the Oracle
  28907, -- Inscription of the Blade
  28908, -- Inscription of the Knight
  28909, -- Greater Inscription of the Orb
  28910, -- Greater Inscription of the Blade
  28911, -- Greater Inscription of the Knight
  28912, -- Greater Inscription of the Oracle
  29162, -- Galaxis Soul Shard
  29187, -- Inscription of Endurance
  29443, -- Bloodmaul Brutebane Brew
  29528, -- Drums of War
  29529, -- Drums of Battle
  29530, -- Drums of Speed
  29532, -- Drums of Panic
  29624, -- First Half of Socrethar's Stone
  29625, -- Second Half of Socrethar's Stone
  29699, -- Socrethar's Teleportation Stone
  29735, -- Holy Dust
  29736, -- Arcane Rune
  29796, -- Socrethar's Teleportation Stone
  29905, -- Kael's Vial Remnant
  29906, -- Vashj's Vial Remnant
  30260, -- Voren'thal's Package
  30309, -- Stonebreaker Brew
  30499, -- Brightsong Wine
  30615, -- Halaani Whiskey
  30858, -- Peon Sleep Potion
  31121, -- Costume Scraps
  31122, -- Overseer Disguise
  31337, -- Orb of the Blackwhelp
  31437, -- Medicinal Drake Essence
  31449, -- Distilled Stalker Sight
  31450, -- Stealth of the Stalker
  31495, -- Grishnath Orb
  31517, -- Dire Pinfeather
  31518, -- Exorcism Feather
  31795, -- Draenei Prayer Beads
  32408, -- Naj'entus Spine
  32576, -- Depleted Crystal Focus
  32839, -- Cauldron of Major Arcane Protection
  32848, -- Explosives Package
  32849, -- Cauldron of Major Fire Protection
  32850, -- Cauldron of Major Frost Protection
  32851, -- Cauldron of Major Nature Protection
  32852, -- Cauldron of Major Shadow Protection
  32971, -- Water Bucket
  33081, -- Voodoo Skull
  33083, -- Orcish Grog
  33218, -- Goblin Gumbo
  33226, -- Tricky Treat
  33277, -- Tome of Thomas Thomson
  33797, -- Portable Brewfest Keg
  33865, -- Amani Hex Stick
  33926, -- Sealed Scroll Case
  33928, -- Hollowed Bone Decanter
  33929, -- Brewfest Brew
  33930, -- Amani Charm of the Bloodletter
  33931, -- Amani Charm of Mighty Mojo
  33932, -- Amani Charm of the Witch Doctor
  33933, -- Amani Charm of the Raging Defender
  33956, -- Echo Isles Pale Ale
  34068, -- Weighted Jack-o'-Lantern
  34077, -- Crudely Wrapped Gift
  34258, -- Love Rocket
  34583, -- Aldor Supplies Package
  34584, -- Scryer Supplies Package
  34585, -- Scryer Supplies Package
  34587, -- Aldor Supplies Package
  34592, -- Aldor Supplies Package
  34593, -- Scryer Supplies Package
  34594, -- Scryer Supplies Package
  34595, -- Aldor Supplies Package
  34599, -- Juggling Torch
  34850, -- Midsummer Ground Flower
  35223, -- Papa Hummel's Old-Fashioned Pet Biscuit
  35232, -- Shattered Sun Supplies
  35512, -- Pocket Full of Snow
  35945, -- Brilliant Glass
  36748, -- Dark Brewmaiden's Brew
  36877, -- Folded Letter
  37496, -- Binary Brew
  37497, -- Autumnal Acorn Ale
  37582, -- Pyroblast Cinnamon Ball
  37583, -- G.N.E.R.D.S.
  37584, -- Soothing Spearmint Candy
  37585, -- Chewy Fel Taffy
  37604, -- Tooth Pick
  37750, -- Fresh Brewfest Hops
  37863, -- Direbrew's Remote
  37902, -- Springtime Stout
  37903, -- Blackrock Lager
  37904, -- Stranglethorn Brew
  37905, -- Draenic Pale Ale
  38186, -- Ethereal Credit
  38233, -- Path of Illidan
  38291, -- Ethereal Mutagen
  38294, -- Ethereal Liqueur
  38300, -- Diluted Ethereum Essence
  38308, -- Ethereal Essence Sphere
  38320, -- Dire Brew
  38518, -- Cro's Apple
  38577, -- Party G.R.E.N.A.D.E.
  39476, -- Fresh Goblin Brewfest Hops
  39477, -- Fresh Dwarven Brewfest Hops
}

-- Elixirs
database["Elixirs"] = {
  22823, -- Elixir of Camouflage
  22824, -- Elixir of Major Strength
  22825, -- Elixir of Healing Power
  22827, -- Elixir of Major Frost Power
  22830, -- Elixir of the Searching Eye
  22831, -- Elixir of Major Agility
  22833, -- Elixir of Major Firepower
  22834, -- Elixir of Major Defense
  22835, -- Elixir of Major Shadow Power
  22840, -- Elixir of Major Mageblood
  22848, -- Elixir of Empowerment
  23444, -- Goldenmist Special Brew
  25539, -- Potion of Water Breathing
  28102, -- Onslaught Elixir
  28103, -- Adept's Elixir
  28104, -- Elixir of Mastery
  31679, -- Fel Strength Elixir
  32062, -- Elixir of Major Fortitude
  32063, -- Earthen Elixir
  32067, -- Elixir of Draenic Wisdom
  32068, -- Elixir of Ironskin
  34130, -- Recovery Diver's Potion
  34537, -- Bloodberry Elixir
}

-- Flasks
database["Flasks"] = {
  22851, -- Flask of Fortification
  22853, -- Flask of Mighty Versatility
  22854, -- Flask of Relentless Assault
  22861, -- Flask of Blinding Light
  22866, -- Flask of Pure Death
  32596, -- Unstable Flask of the Elder
  32597, -- Unstable Flask of the Soldier
  32598, -- Unstable Flask of the Beast
  32599, -- Unstable Flask of the Bandit
  32600, -- Unstable Flask of the Physician
  32601, -- Unstable Flask of the Sorcerer
  32898, -- Shattrath Flask of Fortification
  32899, -- Shattrath Flask of Mighty Restoration
  32900, -- Shattrath Flask of Supreme Power
  32901, -- Shattrath Flask of Relentless Assault
  35716, -- Shattrath Flask of Pure Death
  35717, -- Shattrath Flask of Blinding Light
}

-- Potions
database["Potions"] = {
  22826, -- Sneaking Potion
  22828, -- Insane Strength Potion
  22829, -- Super Healing Potion
  22832, -- Super Mana Potion
  22836, -- Major Dreamless Sleep Potion
  22837, -- Heroic Potion
  22838, -- Haste Potion
  22839, -- Destruction Potion
  22841, -- Major Fire Protection Potion
  22842, -- Major Frost Protection Potion
  22844, -- Major Nature Protection Potion
  22845, -- Major Arcane Protection Potion
  22846, -- Major Shadow Protection Potion
  22847, -- Major Holy Protection Potion
  22849, -- Ironshield Potion
  22850, -- Super Rejuvenation Potion
  22871, -- Shrouding Potion
  28100, -- Volatile Healing Potion
  28101, -- Unstable Mana Potion
  31676, -- Fel Regeneration Potion
  31677, -- Fel Mana Potion
  31853, -- Major Combat Healing Potion
  31855, -- Major Combat Mana Potion
  32783, -- Blue Ogre Brew
  32784, -- Red Ogre Brew
  32840, -- Major Arcane Protection Potion
  32844, -- Major Nature Protection Potion
  32845, -- Major Shadow Protection Potion
  32846, -- Major Fire Protection Potion
  32847, -- Major Frost Protection Potion
  32902, -- Bottled Nethergon Energy
  32903, -- Cenarion Mana Salve
  32904, -- Cenarion Healing Salve
  32905, -- Bottled Nethergon Vapor
  32909, -- Blue Ogre Brew Special
  32910, -- Red Ogre Brew Special
  32947, -- Auchenai Healing Potion
  32948, -- Auchenai Mana Potion
  33092, -- Healing Potion Injector
  33093, -- Mana Potion Injector
  33934, -- Crystal Healing Potion
  33935, -- Crystal Mana Potion
  34440, -- Mad Alchemist's Potion
  35287, -- Luminous Bluetail
}

-- Gems
database["Gems"] = {
  22459, -- Void Sphere
  22460, -- Prismatic Sphere
  23094, -- Brilliant Blood Garnet
  23095, -- Bold Blood Garnet
  23098, -- Inscribed Flame Spessarite
  23099, -- Reckless Flame Spessarite
  23100, -- Glinting Shadow Draenite
  23101, -- Potent Flame Spessarite
  23103, -- Radiant Deep Peridot
  23104, -- Jagged Deep Peridot
  23105, -- Regal Deep Peridot
  23108, -- Timeless Shadow Draenite
  23109, -- Purified Shadow Draenite
  23110, -- Shifting Shadow Draenite
  23111, -- Sovereign Shadow Draenite
  23114, -- Smooth Golden Draenite
  23115, -- Subtle Golden Draenite
  23116, -- Rigid Azure Moonstone
  23118, -- Solid Azure Moonstone
  23119, -- Sparkling Azure Moonstone
  23120, -- Stormy Azure Moonstone
  24027, -- Bold Living Ruby
  24028, -- Delicate Living Ruby
  24030, -- Brilliant Living Ruby
  24032, -- Subtle Dawnstone
  24033, -- Solid Star of Elune
  24035, -- Sparkling Star of Elune
  24036, -- Flashing Living Ruby
  24039, -- Stormy Star of Elune
  24048, -- Smooth Dawnstone
  24051, -- Rigid Star of Elune
  24053, -- Mystic Dawnstone
  24054, -- Sovereign Nightseye
  24055, -- Shifting Nightseye
  24056, -- Timeless Nightseye
  24058, -- Inscribed Noble Topaz
  24059, -- Potent Noble Topaz
  24060, -- Reckless Noble Topaz
  24061, -- Glinting Nightseye
  24065, -- Purified Nightseye
  24066, -- Radiant Talasite
  24067, -- Jagged Talasite
  25890, -- Destructive Skyfire Diamond
  25893, -- Mystical Skyfire Diamond
  25894, -- Swift Skyfire Diamond
  25895, -- Enigmatic Skyfire Diamond
  25896, -- Powerful Earthstorm Diamond
  25897, -- Bracing Earthstorm Diamond
  25898, -- Tenacious Earthstorm Diamond
  25899, -- Brutal Earthstorm Diamond
  25901, -- Insightful Earthstorm Diamond
  27679, -- Mystic Dawnstone
  27777, -- Brilliant Blood Garnet
  27786, -- Jagged Deep Peridot
  27809, -- Jagged Deep Peridot
  27812, -- Brilliant Blood Garnet
  28118, -- Brilliant Ornate Ruby
  28119, -- Smooth Ornate Dawnstone
  28123, -- Potent Ornate Topaz
  28290, -- Smooth Golden Draenite
  28360, -- Delicate Blood Garnet
  28361, -- Delicate Blood Garnet
  28362, -- Delicate Ornate Ruby
  28363, -- Deadly Ornate Topaz
  28458, -- Bold Tourmaline
  28459, -- Delicate Tourmaline
  28461, -- Brilliant Tourmaline
  28463, -- Solid Zircon
  28464, -- Sparkling Zircon
  28467, -- Smooth Amber
  28468, -- Rigid Zircon
  28470, -- Subtle Amber
  28556, -- Swift Windfire Diamond
  28557, -- Quickened Starfire Diamond
  28595, -- Delicate Blood Garnet
  30546, -- Sovereign Tanzanite
  30547, -- Reckless Fire Opal
  30548, -- Jagged Chrysoprase
  30549, -- Shifting Tanzanite
  30550, -- Misty Chrysoprase
  30551, -- Reckless Fire Opal
  30552, -- Timeless Tanzanite
  30553, -- Glinting Tanzanite
  30554, -- Stalwart Fire Opal
  30555, -- Timeless Tanzanite
  30556, -- Glinting Tanzanite
  30558, -- Stalwart Fire Opal
  30559, -- Etched Tanzanite
  30560, -- Misty Chrysoprase
  30563, -- Regal Chrysoprase
  30564, -- Veiled Tanzanite
  30565, -- Jagged Chrysoprase
  30566, -- Defender's Tanzanite
  30571, -- Don Rodrigo's Heart
  30572, -- Purified Tanzanite
  30573, -- Mysterious Tanzanite
  30574, -- Shifting Tanzanite
  30575, -- Nimble Chrysoprase
  30581, -- Willful Fire Opal
  30582, -- Deadly Fire Opal
  30583, -- Timeless Tanzanite
  30584, -- Inscribed Fire Opal
  30585, -- Polished Fire Opal
  30586, -- Purified Tanzanite
  30587, -- Champion's Fire Opal
  30588, -- Potent Fire Opal
  30589, -- Purified Tanzanite
  30590, -- Regal Chrysoprase
  30591, -- Lucent Fire Opal
  30592, -- Steady Chrysoprase
  30593, -- Potent Fire Opal
  30594, -- Regal Chrysoprase
  30598, -- Don Amancio's Heart
  30600, -- Purified Tanzanite
  30601, -- Steady Chrysoprase
  30602, -- Jagged Chrysoprase
  30603, -- Purified Tanzanite
  30604, -- Resplendent Fire Opal
  30605, -- Nimble Chrysoprase
  30606, -- Lightning Chrysoprase
  30607, -- Splendid Fire Opal
  30608, -- Radiant Chrysoprase
  31116, -- Timeless Amethyst
  31117, -- Tireless Soothing Amethyst
  31118, -- Sovereign Amethyst
  31866, -- Veiled Shadow Draenite
  31867, -- Veiled Nightseye
  31868, -- Deadly Noble Topaz
  31869, -- Deadly Flame Spessarite
  32193, -- Bold Crimson Spinel
  32194, -- Delicate Crimson Spinel
  32196, -- Brilliant Crimson Spinel
  32198, -- Subtle Lionseye
  32199, -- Flashing Crimson Spinel
  32200, -- Solid Empyrean Sapphire
  32201, -- Sparkling Empyrean Sapphire
  32203, -- Stormy Empyrean Sapphire
  32205, -- Smooth Lionseye
  32206, -- Rigid Empyrean Sapphire
  32209, -- Mystic Lionseye
  32211, -- Sovereign Shadowsong Amethyst
  32212, -- Shifting Shadowsong Amethyst
  32215, -- Timeless Shadowsong Amethyst
  32217, -- Inscribed Pyrestone
  32218, -- Potent Pyrestone
  32220, -- Glinting Shadowsong Amethyst
  32221, -- Veiled Shadowsong Amethyst
  32222, -- Deadly Pyrestone
  32223, -- Regal Seaspray Emerald
  32224, -- Radiant Seaspray Emerald
  32225, -- Purified Shadowsong Amethyst
  32226, -- Jagged Seaspray Emerald
  32409, -- Relentless Earthstorm Diamond
  32410, -- Thundering Skyfire Diamond
  32634, -- Shifting Amethyst
  32635, -- Timeless Amethyst
  32636, -- Purified Amethyst
  32637, -- Deadly Citrine
  32638, -- Reckless Citrine
  32639, -- Jagged Mossjewel
  32640, -- Tense Unstable Diamond
  32641, -- Imbued Unstable Diamond
  32833, -- Purified Jaggal Pearl
  32836, -- Purified Shadow Pearl
  33131, -- Crimson Sun
  33133, -- Don Julio's Heart
  33134, -- Kailee's Rose
  33135, -- Falling Star
  33140, -- Blood of Amber
  33143, -- Stone of Blades
  33144, -- Facet of Eternity
  33782, -- Steady Talasite
  34220, -- Chaotic Skyfire Diamond
  34831, -- Eye of the Sea
  35315, -- Quick Dawnstone
  35318, -- Forceful Talasite
  35487, -- Delicate Crimson Spinel
  35488, -- Brilliant Crimson Spinel
  35501, -- Eternal Earthstorm Diamond
  35503, -- Ember Skyfire Diamond
  35707, -- Regal Talasite
  35758, -- Steady Seaspray Emerald
  35759, -- Forceful Seaspray Emerald
  35760, -- Reckless Pyrestone
  35761, -- Quick Lionseye
}

-- Permanent Enhancements
database["PermanentEnhancements"] = {
  23530, -- Felsteel Shield Spike
  23764, -- Adamantite Scope
  23765, -- Khorium Scope
  23766, -- Stabilized Eternium Scope
  24273, -- Mystic Spellthread
  24274, -- Runic Spellthread
  24275, -- Silver Spellthread
  24276, -- Golden Spellthread
  25650, -- Knothide Armor Kit
  25651, -- Vindicator's Armor Kit
  25652, -- Magister's Armor Kit
  29533, -- Cobrahide Leg Armor
  29534, -- Clefthide Leg Armor
  29535, -- Nethercobra Leg Armor
  29536, -- Nethercleft Leg Armor
  33185, -- Adamantite Weapon Chain
  34207, -- Glove Reinforcements
  34330, -- Heavy Knothide Armor Kit
  34836, -- Spun Truesilver Fishing Line
}

-- Temporary Enhancements
database["TemporaryEnhancements"] = {
  22521, -- Superior Mana Oil
  22522, -- Superior Wizard Oil
  23528, -- Fel Sharpening Stone
  23529, -- Adamantite Sharpening Stone
  23559, -- Lesser Rune of Warding
  23575, -- Lesser Ward of Shielding
  23576, -- Greater Ward of Shielding
  25521, -- Greater Rune of Warding
  25679, -- Comfortable Insoles
  28420, -- Fel Weightstone
  28421, -- Adamantite Weightstone
  31535, -- Bloodboil Poison
  34538, -- Blessed Weapon Coating
  34539, -- Righteous Weapon Coating
  34861, -- Sharpened Fish Hook
}

-- Cloth
database["Cloth"] = {
  21840, -- Bolt of Netherweave
  21842, -- Bolt of Imbued Netherweave
  21844, -- Bolt of Soulcloth
  21845, -- Primal Mooncloth
  21877, -- Netherweave Cloth
  21881, -- Netherweb Spider Silk
  24271, -- Spellcloth
  24272, -- Shadowcloth
}

-- Elemental
database["Elemental"] = {
  21884, -- Primal Fire
  21885, -- Primal Water
  21886, -- Primal Life
  22451, -- Primal Air
  22452, -- Primal Earth
  22456, -- Primal Shadow
  22457, -- Primal Mana
  22572, -- Mote of Air
  22573, -- Mote of Earth
  22574, -- Mote of Fire
  22575, -- Mote of Life
  22576, -- Mote of Mana
  22577, -- Mote of Shadow
  22578, -- Mote of Water
  23571, -- Primal Might
  23572, -- Primal Nether
  30183, -- Nether Vortex
}

-- Enchanting
database["Enchanting"] = {
  22445, -- Arcane Dust
  22446, -- Greater Planar Essence
  22447, -- Lesser Planar Essence
  22448, -- Small Prismatic Shard
  22449, -- Large Prismatic Shard
  22450, -- Void Crystal
}

-- Herbs
database["Herbs"] = {
  22710, -- Bloodthistle
  22785, -- Felweed
  22786, -- Dreaming Glory
  22787, -- Ragveil
  22788, -- Flame Cap
  22789, -- Terocone
  22790, -- Ancient Lichen
  22791, -- Netherbloom
  22792, -- Nightmare Vine
  22793, -- Mana Thistle
  22794, -- Fel Lotus
  22797, -- Nightmare Seed
}

-- Inscription
database["Inscription"] = {
  31882, -- Ace of Blessings
  31883, -- Eight of Blessings
  31884, -- Five of Blessings
  31885, -- Four of Blessings
  31886, -- Seven of Blessings
  31887, -- Six of Blessings
  31888, -- Three of Blessings
  31889, -- Two of Blessings
  31892, -- Ace of Storms
  31893, -- Eight of Storms
  31894, -- Five of Storms
  31895, -- Four of Storms
  31896, -- Seven of Storms
  31898, -- Six of Storms
  31899, -- Three of Storms
  31900, -- Two of Storms
  31901, -- Ace of Furies
  31902, -- Eight of Furies
  31903, -- Five of Furies
  31904, -- Four of Furies
  31905, -- Seven of Furies
  31906, -- Six of Furies
  31908, -- Three of Furies
  31909, -- Two of Furies
  31910, -- Ace of Lunacy
  31911, -- Eight of Lunacy
  31912, -- Five of Lunacy
  31913, -- Four of Lunacy
  31915, -- Seven of Lunacy
  31916, -- Six of Lunacy
  31917, -- Three of Lunacy
  31918, -- Two of Lunacy
}

-- Jewelcrafting
database["Jewelcrafting"] = {
  20816, -- Delicate Copper Wire
  20817, -- Bronze Setting
  20963, -- Mithril Filigree
  21752, -- Thorium Setting
  21929, -- Flame Spessarite
  23077, -- Blood Garnet
  23079, -- Deep Peridot
  23107, -- Shadow Draenite
  23112, -- Golden Draenite
  23117, -- Azure Moonstone
  23436, -- Living Ruby
  23437, -- Talasite
  23438, -- Star of Elune
  23439, -- Noble Topaz
  23440, -- Dawnstone
  23441, -- Nightseye
  24243, -- Adamantite Powder
  24478, -- Jaggal Pearl
  24479, -- Shadow Pearl
  25867, -- Earthstorm Diamond
  25868, -- Skyfire Diamond
  31079, -- Mercurial Adamantite
  32227, -- Crimson Spinel
  32228, -- Empyrean Sapphire
  32229, -- Lionseye
  32230, -- Shadowsong Amethyst
  32231, -- Pyrestone
  32249, -- Seaspray Emerald
}

-- Leather
database["Leather"] = {
  21887, -- Knothide Leather
  23793, -- Heavy Knothide Leather
  25649, -- Knothide Leather Scraps
  25699, -- Crystal Infused Leather
  25700, -- Fel Scales
  25707, -- Fel Hide
  25708, -- Thick Clefthoof Leather
  29539, -- Cobra Scales
  29547, -- Wind Scales
  29548, -- Nether Dragonscales
}

-- Meat & Fish
database["MeatFish"] = {
  22644, -- Crunchy Spider Leg
  23676, -- Moongraze Stag Tenderloin
  24477, -- Jaggal Clam Meat
  27422, -- Barbed Gill Trout
  27425, -- Spotted Feltail
  27429, -- Zangarian Sporefish
  27435, -- Figluster's Mudfish
  27437, -- Icefin Bluefish
  27438, -- Golden Darter
  27439, -- Furious Crawdad
  27668, -- Lynx Meat
  27669, -- Bat Flesh
  27671, -- Buzzard Meat
  27674, -- Ravager Flesh
  27677, -- Chunk o' Basilisk
  27678, -- Clefthoof Meat
  27681, -- Warped Flesh
  27682, -- Talbuk Venison
  31670, -- Raptor Ribs
  31671, -- Serpent Flesh
  33823, -- Bloodfin Catfish
  33824, -- Crescent-Tail Skullfish
  35285, -- Giant Sunfish
  35562, -- Bear Flank
  37588, -- Mostly Digested Fish
}

-- Metal & Stone
database["MetalStone"] = {
  23424, -- Fel Iron Ore
  23425, -- Adamantite Ore
  23426, -- Khorium Ore
  23427, -- Eternium Ore
  23445, -- Fel Iron Bar
  23446, -- Adamantite Bar
  23447, -- Eternium Bar
  23448, -- Felsteel Bar
  23449, -- Khorium Bar
  23573, -- Hardened Adamantite Bar
  35128, -- Hardened Khorium
}

-- Other Tradegoods
database["OtherTradegoods"] = {
  21882, -- Soul Essence
  24476, -- Jaggal Clam
  27511, -- Inscribed Scrollcase
  27513, -- Curious Crate
  30817, -- Simple Flour
  32428, -- Heart of Darkness
  34664, -- Sunmote
}

-- Parts
database["Parts"] = {
  23781, -- Elemental Blasting Powder
  23782, -- Fel Iron Casing
  23783, -- Handful of Fel Iron Bolts
  23784, -- Adamantite Frame
  23785, -- Hardened Adamantite Tube
  23786, -- Khorium Power Core
  23787, -- Felsteel Stabilizer
  32423, -- Icy Blasting Primers
}

local function converttohex(rgb)
  return string.format("%02x%02x%02x", rgb.r * 255, rgb.g * 255, rgb.b * 255)
end

local function converttorgb(hex, as_table)
  if as_table then
    return {
      r = tonumber("0x" .. strsub(hex, 1, 2)) / 255,
      g = tonumber("0x" .. strsub(hex, 3, 4)) / 255,
      b = tonumber("0x" .. strsub(hex, 5, 6)) / 255,
    }
  else
    -- as 3 values
    return tonumber("0x" .. hex:sub(1, 2)) / 255,
      tonumber("0x" .. hex:sub(3, 4)) / 255,
      tonumber("0x" .. hex:sub(5, 6)) / 255
  end
end


local function formatBagTitle(self, title, hex)
  local prefix = ""
  if self.db.profile.prefixCategories then
    if self.db.profile.prefixCategories == "!CUSTOM" then
      prefix = self.db.profile.customPrefix
    else
      prefix = self.db.profile.prefixCategories
    end
  end
  if self.db.profile.coloredPrefix then
    prefix = "|cff" .. converttohex(self.db.profile.color.prefix) .. prefix .. "|r"
    if self.db.profile.coloredCategories then
      return prefix .. "|cff" .. hex .. title .. "|r"
    else
      return prefix .. title
    end
  else
    if self.db.profile.coloredCategories then
      return prefix .. "|cff" .. hex .. title .. "|r"
    else
      return prefix .. title
    end
  end
end

local function MatchIDs_Init(self)
  wipe(Result)

  if self.db.profile.moveMergedConsumables then
    Result[formatBagTitle(self, L["Consumables"], converttohex(self.db.profile.color.mergedConsumables))] =
      AddToSet(database["Bandages"], database["Consumables"], database["FoodsandDrinks"], database["OtherConsumables"])
  else
    if self.db.profile.moveBandages then
      Result[formatBagTitle(self, L["Bandages"], converttohex(self.db.profile.color.Bandages))] =
        AddToSet(database["Bandages"])
    end
    if self.db.profile.moveConsumables then
      Result[formatBagTitle(self, L["Consumables"], converttohex(self.db.profile.color.Consumables))] =
        AddToSet(database["Consumables"])
    end
    if self.db.profile.moveFoodsandDrinks then
      Result[formatBagTitle(self, L["Foods and Drinks"], converttohex(self.db.profile.color.FoodsandDrinks))] =
        AddToSet(database["FoodsandDrinks"])
    end
    if self.db.profile.moveOtherConsumables then
      Result[formatBagTitle(self, L["Other Consumables"], converttohex(self.db.profile.color.OtherConsumables))] =
        AddToSet(database["OtherConsumables"])
    end
  end
  if self.db.profile.moveMergedFlasksElixirsPotions then
    Result[formatBagTitle(
      self,
      L["Flasks, Elixirs & Potions"],
      converttohex(self.db.profile.color.mergedFlasksElixirsPotions)
    )] =
      AddToSet(database["Elixirs"], database["Flasks"], database["Potions"])
  else
    if self.db.profile.moveElixirs then
      Result[formatBagTitle(self, L["Elixirs"], converttohex(self.db.profile.color.Elixirs))] =
        AddToSet(database["Elixirs"])
    end
    if self.db.profile.moveFlasks then
      Result[formatBagTitle(self, L["Flasks"], converttohex(self.db.profile.color.Flasks))] =
        AddToSet(database["Flasks"])
    end
    if self.db.profile.movePotions then
      Result[formatBagTitle(self, L["Potions"], converttohex(self.db.profile.color.Potions))] =
        AddToSet(database["Potions"])
    end
  end
  if self.db.profile.moveMergedTemporaryPermanentEnhancements then
    Result[formatBagTitle(
      self,
      L["Temporary & Permanent Enhancements"],
      converttohex(self.db.profile.color.mergedTemporaryPermanentEnhancements)
    )] =
      AddToSet(database["Gems"], database["PermanentEnhancements"], database["TemporaryEnhancements"])
  else
    if self.db.profile.moveGems then
      Result[formatBagTitle(self, L["Gems"], converttohex(self.db.profile.color.Gems))] = AddToSet(database["Gems"])
    end
    if self.db.profile.movePermanentEnhancements then
      Result[formatBagTitle(
        self,
        L["Permanent Enhancements"],
        converttohex(self.db.profile.color.PermanentEnhancements)
      )] =
        AddToSet(database["PermanentEnhancements"])
    end
    if self.db.profile.moveTemporaryEnhancements then
      Result[formatBagTitle(
        self,
        L["Temporary Enhancements"],
        converttohex(self.db.profile.color.TemporaryEnhancements)
      )] =
        AddToSet(database["TemporaryEnhancements"])
    end
  end
  if self.db.profile.moveMergedTradegoods then
    Result[formatBagTitle(self, L["Tradegoods"], converttohex(self.db.profile.color.mergedTradegoods))] = AddToSet(
      database["Cloth"],
      database["Elemental"],
      database["Enchanting"],
      database["Herbs"],
      database["Inscription"],
      database["Jewelcrafting"],
      database["Leather"],
      database["MeatFish"],
      database["MetalStone"],
      database["OtherTradegoods"],
      database["Parts"]
    )
  else
    if self.db.profile.moveCloth then
      Result[formatBagTitle(self, L["Cloth"], converttohex(self.db.profile.color.Cloth))] = AddToSet(database["Cloth"])
    end
    if self.db.profile.moveElemental then
      Result[formatBagTitle(self, L["Elemental"], converttohex(self.db.profile.color.Elemental))] =
        AddToSet(database["Elemental"])
    end
    if self.db.profile.moveEnchanting then
      Result[formatBagTitle(self, L["Enchanting"], converttohex(self.db.profile.color.Enchanting))] =
        AddToSet(database["Enchanting"])
    end
    if self.db.profile.moveHerbs then
      Result[formatBagTitle(self, L["Herbs"], converttohex(self.db.profile.color.Herbs))] = AddToSet(database["Herbs"])
    end
    if self.db.profile.moveInscription then
      Result[formatBagTitle(self, L["Inscription"], converttohex(self.db.profile.color.Inscription))] =
        AddToSet(database["Inscription"])
    end
    if self.db.profile.moveJewelcrafting then
      Result[formatBagTitle(self, L["Jewelcrafting"], converttohex(self.db.profile.color.Jewelcrafting))] =
        AddToSet(database["Jewelcrafting"])
    end
    if self.db.profile.moveLeather then
      Result[formatBagTitle(self, L["Leather"], converttohex(self.db.profile.color.Leather))] =
        AddToSet(database["Leather"])
    end
    if self.db.profile.moveMeatFish then
      Result[formatBagTitle(self, L["Meat & Fish"], converttohex(self.db.profile.color.MeatFish))] =
        AddToSet(database["MeatFish"])
    end
    if self.db.profile.moveMetalStone then
      Result[formatBagTitle(self, L["Metal & Stone"], converttohex(self.db.profile.color.MetalStone))] =
        AddToSet(database["MetalStone"])
    end
    if self.db.profile.moveOtherTradegoods then
      Result[formatBagTitle(self, L["Other Tradegoods"], converttohex(self.db.profile.color.OtherTradegoods))] =
        AddToSet(database["OtherTradegoods"])
    end
    if self.db.profile.moveParts then
      Result[formatBagTitle(self, L["Parts"], converttohex(self.db.profile.color.Parts))] = AddToSet(database["Parts"])
    end
  end

  return Result
end

local setFilter = AdiBags:RegisterFilter("Burning Crusade", 98, "ABEvent-1.0")
setFilter.uiName = string.format("|cff00bc04%s|r", L["Burning Crusade"])
setFilter.uiDesc = string.format(
  "%s\n|cffffd800%s: 1.0.0|r",
  L["Items from the Burning Crusade expansion."],
  L["Filter version"]
)

function setFilter:OnInitialize()
  self.db = AdiBags.db:RegisterNamespace("Burning Crusade", {
    profile = {
      coloredCategories = true,
      prefixCategories = "",
      customPrefix = "",
      coloredPrefix = true,
      moveMergedConsumables = false,
      moveBandages = true,
      moveConsumables = true,
      moveFoodsandDrinks = true,
      moveOtherConsumables = true,
      moveMergedFlasksElixirsPotions = true,
      moveElixirs = true,
      moveFlasks = true,
      movePotions = true,
      moveMergedTemporaryPermanentEnhancements = true,
      moveGems = true,
      movePermanentEnhancements = true,
      moveTemporaryEnhancements = true,
      moveMergedTradegoods = true,
      moveCloth = true,
      moveElemental = true,
      moveEnchanting = true,
      moveHerbs = true,
      moveInscription = true,
      moveJewelcrafting = true,
      moveLeather = true,
      moveMeatFish = true,
      moveMetalStone = true,
      moveOtherTradegoods = true,
      moveParts = true,

      color = {
        prefix = converttorgb("00bc04", true),
        mergedConsumables = converttorgb("7aa36f", true),
        Bandages = converttorgb("fff600", true),
        Consumables = converttorgb("49678d", true),
        FoodsandDrinks = converttorgb("9b59b6", true),
        OtherConsumables = converttorgb("4e878c", true),
        mergedFlasksElixirsPotions = converttorgb("769fb6", true),
        Elixirs = converttorgb("689a8c", true),
        Flasks = converttorgb("b60f96", true),
        Potions = converttorgb("9dbbae", true),
        mergedTemporaryPermanentEnhancements = converttorgb("5a7684", true),
        Gems = converttorgb("ff00ea", true),
        PermanentEnhancements = converttorgb("92afd7", true),
        TemporaryEnhancements = converttorgb("c5d1eb", true),
        mergedTradegoods = converttorgb("786f52", true),
        Cloth = converttorgb("feb95f", true),
        Elemental = converttorgb("c2095a", true),
        Enchanting = converttorgb("540d6e", true),
        Herbs = converttorgb("0ead69", true),
        Inscription = converttorgb("ffd23f", true),
        Jewelcrafting = converttorgb("090446", true),
        Leather = converttorgb("563635", true),
        MeatFish = converttorgb("f71735", true),
        MetalStone = converttorgb("6e9075", true),
        OtherTradegoods = converttorgb("81f0e5", true),
        Parts = converttorgb("5b6057", true),
      },
    },
  })
end

function setFilter:Update()
  MatchIDs = nil
  self:SendMessage("AdiBags_FiltersChanged")
end

function setFilter:OnEnable()
  AdiBags:UpdateFilters()
end

function setFilter:OnDisable()
  AdiBags:UpdateFilters()
end

function setFilter:Filter(slotData)
  MatchIDs = MatchIDs or MatchIDs_Init(self)
  for i, name in pairs(MatchIDs) do
    -- Override Method
    if MatchIDs[i]["override"] then
      slotData["loc"] = ItemLocation:CreateFromBagAndSlot(slotData.bag, slotData.slot)
      if slotData["loc"] and slotData["loc"]:IsValid() then
        if MatchIDs[i]["override"](slotData.loc) then
          return i
        end
      end

      -- Bonus Condition (triggers when bonus condition is not fulfilled)
    elseif MatchIDs[i]["bonus_condition"] then
      if name[slotData.itemId] then
        slotData["loc"] = ItemLocation:CreateFromBagAndSlot(slotData.bag, slotData.slot)
        if slotData["loc"] and slotData["loc"]:IsValid() then
          if not MatchIDs[i]["bonus_condition"](slotData.loc) then
            -- THERE IS A NOT HERE!
            return i
          end
        end
      end

      -- Standard ID Matching
    elseif name[slotData.itemId] then
      return i
    end
  end
end

function setFilter:GetOptions()
  return {
    general_config = {
      type = "group",
      name = L["General Settings"],
      desc = L["Settings affecting all categories."],
      inline = true,
      order = 1,
      args = {
        description = {
          type = "description",
          name = string.format(
            "%s |cffffd800%s |cff529F00%s|r",
            L["These settings affect all categories of this filter."],
            L["If you overwrite prefix or categorie color, you either need to toggle the color setting twice or reload."],
            L["AdiBags never intended to use icons, so they are glitchy. Make sure to disable prefix color, if you use an icon."]
          ),
          order = 1,
        },
        coloredCategories = {
          name = string.format("|cffFDFD96%s|r", L["Colored Categories"]),
          desc = L["Should Categories be colored?"],
          width = "full",
          type = "toggle",
          order = 10,
        },
        prefixCategories = {
          name = L["Prefix Categories"],
          desc = L["Select a prefix for the categories, if you like."],
          type = "select",
          order = 20,
          values = {
            [""] = L["None"],
            ["!CUSTOM"] = L["Custom Prefix"],
            ["BC"] = "BC",
            ["BC-"] = "BC-",
            ["1."] = "1.",
            ["|T135891:" .. AdiBags.HEADER_SIZE .. ":" .. AdiBags.HEADER_SIZE .. ":-2:-10|t"] = "|T135891:"
              .. AdiBags.HEADER_SIZE
              .. "|t",
            ["|T1380867:" .. AdiBags.HEADER_SIZE .. ":" .. AdiBags.HEADER_SIZE .. ":-2:-10|t"] = "|T1380867:"
              .. AdiBags.HEADER_SIZE
              .. "|t",
            ["|T1546412:" .. AdiBags.HEADER_SIZE .. ":" .. AdiBags.HEADER_SIZE .. ":-2:-10|t"] = "|T1546412:"
              .. AdiBags.HEADER_SIZE
              .. "|t",
            ["|T236412:" .. AdiBags.HEADER_SIZE .. ":" .. AdiBags.HEADER_SIZE .. ":-2:-10|t"] = "|T236412:"
              .. AdiBags.HEADER_SIZE
              .. "|t",
            ["|T236418:" .. AdiBags.HEADER_SIZE .. ":" .. AdiBags.HEADER_SIZE .. ":-2:-10|t"] = "|T236418:"
              .. AdiBags.HEADER_SIZE
              .. "|t",
          },
        },
        customPrefix = {
          name = L["Custom Prefix"],
          desc = L["Enter a custom prefix for the categories."],
          type = "input",
          order = 30,
          width = "full",
          disabled = function()
            return self.db.profile.prefixCategories ~= "!CUSTOM"
          end,
        },
        coloredPrefix = {
          name = string.format("|cffB9FFB9%s|r", L["Colored Prefix"]),
          desc = L["Should the prefix be colored to the filter color? (Only works for text-prefixes, for obvious reasons.)"],
          type = "toggle",
          order = 40,
        },
        prefixColor = {
          name = L["Prefix Color"],
          desc = L["Select a color for the prefix."],
          type = "color",
          order = 50,
          hasAlpha = false,
          disabled = function()
            return not self.db.profile.coloredPrefix
          end,
          get = function()
            local color = self.db.profile.color.prefix
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.prefix
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
      },
    },
    Consumables_config = {
      type = "group",
      name = L["Consumables"],
      desc = "", -- doesnt work,
      inline = true,
      order = 52,
      args = {
        Legendaries_desc = {
          type = "description",
          name = L["Items you can eat or use to improve yourself"],
          order = 53,
        },
        moveMergedConsumables = {
          name = string.format(L["%sMerge %s%s"], "|cffffd800", L["Consumables"], "|r"),
          desc = string.format(L["Merge all %s into a single category."], L["Consumables"]),
          type = "toggle",
          width = 1.5,
          order = 54,
        },
        colorMergedConsumables = {
          name = L["Color"],
          desc = string.format(L["Select a color for the merged %s category."], L["Consumables"]),
          type = "color",
          order = 55,
          hasAlpha = false,
          disabled = function()
            return not self.db.profile.moveMergedConsumables
          end,
          get = function()
            local color = self.db.profile.color.mergedConsumables
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.mergedConsumables
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_1 = {
          type = "header",
          name = "",
          order = 56,
        },
        moveBandages = {
          name = L["Bandages"],
          desc = L["Bandages to heal yourself."],
          type = "toggle",
          width = 1.5,
          order = 57,
          disabled = function()
            return self.db.profile.moveMergedConsumables
          end,
        },
        colorBandages = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Bandages"]),
          type = "color",
          order = 58,
          disabled = function()
            return self.db.profile.moveMergedConsumables
          end,
          get = function()
            local color = self.db.profile.color.Bandages
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Bandages
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_2 = {
          type = "header",
          name = "",
          order = 59,
        },
        moveConsumables = {
          name = L["Consumables"],
          desc = L["Consumables to consume."],
          type = "toggle",
          width = 1.5,
          order = 60,
          disabled = function()
            return self.db.profile.moveMergedConsumables
          end,
        },
        colorConsumables = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Consumables"]),
          type = "color",
          order = 61,
          disabled = function()
            return self.db.profile.moveMergedConsumables
          end,
          get = function()
            local color = self.db.profile.color.Consumables
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Consumables
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_3 = {
          type = "header",
          name = "",
          order = 62,
        },
        moveFoodsandDrinks = {
          name = L["Foods and Drinks"],
          desc = L["Foods and Drinks to consume."],
          type = "toggle",
          width = 1.5,
          order = 63,
          disabled = function()
            return self.db.profile.moveMergedConsumables
          end,
        },
        colorFoodsandDrinks = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Foods and Drinks"]),
          type = "color",
          order = 64,
          disabled = function()
            return self.db.profile.moveMergedConsumables
          end,
          get = function()
            local color = self.db.profile.color.FoodsandDrinks
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.FoodsandDrinks
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_4 = {
          type = "header",
          name = "",
          order = 65,
        },
        moveOtherConsumables = {
          name = L["Other Consumables"],
          desc = L["Other Consumables to consume."],
          type = "toggle",
          width = 1.5,
          order = 66,
          disabled = function()
            return self.db.profile.moveMergedConsumables
          end,
        },
        colorOtherConsumables = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Other Consumables"]),
          type = "color",
          order = 67,
          disabled = function()
            return self.db.profile.moveMergedConsumables
          end,
          get = function()
            local color = self.db.profile.color.OtherConsumables
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.OtherConsumables
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
      },
    },
    FlasksElixirsPotions_config = {
      type = "group",
      name = L["Flasks, Elixirs & Potions"],
      desc = "", -- doesnt work,
      inline = true,
      order = 68,
      args = {
        Legendaries_desc = {
          type = "description",
          name = L["Drink this for a powerup!"],
          order = 69,
        },
        moveMergedFlasksElixirsPotions = {
          name = string.format(L["%sMerge %s%s"], "|cffffd800", L["Flasks, Elixirs & Potions"], "|r"),
          desc = string.format(L["Merge all %s into a single category."], L["Flasks, Elixirs & Potions"]),
          type = "toggle",
          width = 1.5,
          order = 70,
        },
        colorMergedFlasksElixirsPotions = {
          name = L["Color"],
          desc = string.format(L["Select a color for the merged %s category."], L["Flasks, Elixirs & Potions"]),
          type = "color",
          order = 71,
          hasAlpha = false,
          disabled = function()
            return not self.db.profile.moveMergedFlasksElixirsPotions
          end,
          get = function()
            local color = self.db.profile.color.mergedFlasksElixirsPotions
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.mergedFlasksElixirsPotions
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_5 = {
          type = "header",
          name = "",
          order = 72,
        },
        moveElixirs = {
          name = L["Elixirs"],
          desc = L["Elixirs to drink."],
          type = "toggle",
          width = 1.5,
          order = 73,
          disabled = function()
            return self.db.profile.moveMergedFlasksElixirsPotions
          end,
        },
        colorElixirs = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Elixirs"]),
          type = "color",
          order = 74,
          disabled = function()
            return self.db.profile.moveMergedFlasksElixirsPotions
          end,
          get = function()
            local color = self.db.profile.color.Elixirs
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Elixirs
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_6 = {
          type = "header",
          name = "",
          order = 75,
        },
        moveFlasks = {
          name = L["Flasks"],
          desc = L["Flasks to drink."],
          type = "toggle",
          width = 1.5,
          order = 76,
          disabled = function()
            return self.db.profile.moveMergedFlasksElixirsPotions
          end,
        },
        colorFlasks = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Flasks"]),
          type = "color",
          order = 77,
          disabled = function()
            return self.db.profile.moveMergedFlasksElixirsPotions
          end,
          get = function()
            local color = self.db.profile.color.Flasks
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Flasks
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_7 = {
          type = "header",
          name = "",
          order = 78,
        },
        movePotions = {
          name = L["Potions"],
          desc = L["Potions to drink."],
          type = "toggle",
          width = 1.5,
          order = 79,
          disabled = function()
            return self.db.profile.moveMergedFlasksElixirsPotions
          end,
        },
        colorPotions = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Potions"]),
          type = "color",
          order = 80,
          disabled = function()
            return self.db.profile.moveMergedFlasksElixirsPotions
          end,
          get = function()
            local color = self.db.profile.color.Potions
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Potions
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
      },
    },
    TemporaryPermanentEnhancements_config = {
      type = "group",
      name = L["Temporary & Permanent Enhancements"],
      desc = "", -- doesnt work,
      inline = true,
      order = 81,
      args = {
        Legendaries_desc = {
          type = "description",
          name = L["Use these for a powerup!"],
          order = 82,
        },
        moveMergedTemporaryPermanentEnhancements = {
          name = string.format(L["%sMerge %s%s"], "|cffffd800", L["Temporary & Permanent Enhancements"], "|r"),
          desc = string.format(L["Merge all %s into a single category."], L["Temporary & Permanent Enhancements"]),
          type = "toggle",
          width = 1.5,
          order = 83,
        },
        colorMergedTemporaryPermanentEnhancements = {
          name = L["Color"],
          desc = string.format(
            L["Select a color for the merged %s category."],
            L["Temporary & Permanent Enhancements"]
          ),
          type = "color",
          order = 84,
          hasAlpha = false,
          disabled = function()
            return not self.db.profile.moveMergedTemporaryPermanentEnhancements
          end,
          get = function()
            local color = self.db.profile.color.mergedTemporaryPermanentEnhancements
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.mergedTemporaryPermanentEnhancements
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_8 = {
          type = "header",
          name = "",
          order = 85,
        },
        moveGems = {
          name = L["Gems"],
          desc = L["These are gems that you can typically apply to armor to improve it."],
          type = "toggle",
          width = 1.5,
          order = 86,
          disabled = function()
            return self.db.profile.moveMergedTemporaryPermanentEnhancements
          end,
        },
        colorGems = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Gems"]),
          type = "color",
          order = 87,
          disabled = function()
            return self.db.profile.moveMergedTemporaryPermanentEnhancements
          end,
          get = function()
            local color = self.db.profile.color.Gems
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Gems
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_9 = {
          type = "header",
          name = "",
          order = 88,
        },
        movePermanentEnhancements = {
          name = L["Permanent Enhancements"],
          desc = L["These are permanent enhancements that you can typically apply to armor to improve it."],
          type = "toggle",
          width = 1.5,
          order = 89,
          disabled = function()
            return self.db.profile.moveMergedTemporaryPermanentEnhancements
          end,
        },
        colorPermanentEnhancements = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Permanent Enhancements"]),
          type = "color",
          order = 90,
          disabled = function()
            return self.db.profile.moveMergedTemporaryPermanentEnhancements
          end,
          get = function()
            local color = self.db.profile.color.PermanentEnhancements
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.PermanentEnhancements
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_10 = {
          type = "header",
          name = "",
          order = 91,
        },
        moveTemporaryEnhancements = {
          name = L["Temporary Enhancements"],
          desc = L["These are temporary enhancements that you can typically apply to armor to improve it."],
          type = "toggle",
          width = 1.5,
          order = 92,
          disabled = function()
            return self.db.profile.moveMergedTemporaryPermanentEnhancements
          end,
        },
        colorTemporaryEnhancements = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Temporary Enhancements"]),
          type = "color",
          order = 93,
          disabled = function()
            return self.db.profile.moveMergedTemporaryPermanentEnhancements
          end,
          get = function()
            local color = self.db.profile.color.TemporaryEnhancements
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.TemporaryEnhancements
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
      },
    },
    Tradegoods_config = {
      type = "group",
      name = L["Tradegoods"],
      desc = "", -- doesnt work,
      inline = true,
      order = 94,
      args = {
        Legendaries_desc = {
          type = "description",
          name = L["Trading tradegoods is good. Trade tradegoods for good goods."],
          order = 95,
        },
        moveMergedTradegoods = {
          name = string.format(L["%sMerge %s%s"], "|cffffd800", L["Tradegoods"], "|r"),
          desc = string.format(L["Merge all %s into a single category."], L["Tradegoods"]),
          type = "toggle",
          width = 1.5,
          order = 96,
        },
        colorMergedTradegoods = {
          name = L["Color"],
          desc = string.format(L["Select a color for the merged %s category."], L["Tradegoods"]),
          type = "color",
          order = 97,
          hasAlpha = false,
          disabled = function()
            return not self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.mergedTradegoods
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.mergedTradegoods
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_11 = {
          type = "header",
          name = "",
          order = 98,
        },
        moveCloth = {
          name = L["Cloth"],
          desc = L["Cloth used in Tailoring."],
          type = "toggle",
          width = 1.5,
          order = 99,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorCloth = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Cloth"]),
          type = "color",
          order = 100,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.Cloth
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Cloth
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_12 = {
          type = "header",
          name = "",
          order = 101,
        },
        moveElemental = {
          name = L["Elemental"],
          desc = L["Elementals used in all professions."],
          type = "toggle",
          width = 1.5,
          order = 102,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorElemental = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Elemental"]),
          type = "color",
          order = 103,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.Elemental
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Elemental
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_13 = {
          type = "header",
          name = "",
          order = 104,
        },
        moveEnchanting = {
          name = L["Enchanting"],
          desc = L["Enchanting materials for enchanting weapons & armor."],
          type = "toggle",
          width = 1.5,
          order = 105,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorEnchanting = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Enchanting"]),
          type = "color",
          order = 106,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.Enchanting
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Enchanting
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_14 = {
          type = "header",
          name = "",
          order = 107,
        },
        moveHerbs = {
          name = L["Herbs"],
          desc = L["Herbs used in Alchemy & Inscription."],
          type = "toggle",
          width = 1.5,
          order = 108,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorHerbs = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Herbs"]),
          type = "color",
          order = 109,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.Herbs
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Herbs
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_15 = {
          type = "header",
          name = "",
          order = 110,
        },
        moveInscription = {
          name = L["Inscription"],
          desc = L["Inscription materials for creating glyphs or other paper related goods."],
          type = "toggle",
          width = 1.5,
          order = 111,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorInscription = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Inscription"]),
          type = "color",
          order = 112,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.Inscription
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Inscription
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_16 = {
          type = "header",
          name = "",
          order = 113,
        },
        moveJewelcrafting = {
          name = L["Jewelcrafting"],
          desc = L["Jewelcrafting materials for creating rings, necklaces, gems, etc."],
          type = "toggle",
          width = 1.5,
          order = 114,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorJewelcrafting = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Jewelcrafting"]),
          type = "color",
          order = 115,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.Jewelcrafting
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Jewelcrafting
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_17 = {
          type = "header",
          name = "",
          order = 116,
        },
        moveLeather = {
          name = L["Leather"],
          desc = L["Leather used in Leatherworking."],
          type = "toggle",
          width = 1.5,
          order = 117,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorLeather = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Leather"]),
          type = "color",
          order = 118,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.Leather
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Leather
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_18 = {
          type = "header",
          name = "",
          order = 119,
        },
        moveMeatFish = {
          name = L["Meat & Fish"],
          desc = L["Meat & Fish used in Cooking."],
          type = "toggle",
          width = 1.5,
          order = 120,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorMeatFish = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Meat & Fish"]),
          type = "color",
          order = 121,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.MeatFish
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.MeatFish
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_19 = {
          type = "header",
          name = "",
          order = 122,
        },
        moveMetalStone = {
          name = L["Metal & Stone"],
          desc = L["Metal & Stone used in Blacksmithing."],
          type = "toggle",
          width = 1.5,
          order = 123,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorMetalStone = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Metal & Stone"]),
          type = "color",
          order = 124,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.MetalStone
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.MetalStone
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_20 = {
          type = "header",
          name = "",
          order = 125,
        },
        moveOtherTradegoods = {
          name = L["Other Tradegoods"],
          desc = L["Other items used in various professions."],
          type = "toggle",
          width = 1.5,
          order = 126,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorOtherTradegoods = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Other Tradegoods"]),
          type = "color",
          order = 127,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.OtherTradegoods
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.OtherTradegoods
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
        seperator_21 = {
          type = "header",
          name = "",
          order = 128,
        },
        moveParts = {
          name = L["Parts"],
          desc = L["Parts used in Engineering."],
          type = "toggle",
          width = 1.5,
          order = 129,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
        },
        colorParts = {
          name = L["Color"],
          desc = string.format(L["Select a color for %s."], L["Parts"]),
          type = "color",
          order = 130,
          disabled = function()
            return self.db.profile.moveMergedTradegoods
          end,
          get = function()
            local color = self.db.profile.color.Parts
            AdiBags:UpdateFilters()
            return color.r, color.g, color.b
          end,
          set = function(_, r, g, b)
            local color = self.db.profile.color.Parts
            color.r, color.g, color.b = r, g, b
            AdiBags:UpdateFilters()
          end,
        },
      },
    },
  },
    AdiBags:GetOptionHandler(self, false, function()
      return self:Update()
    end)
end
